--- ignore.key.table    2010-09-17 10:53:27.559170458 +0300
+++ force.key.table     2010-09-17 10:53:21.070295920 +0300
@@ -1,16 +1,11 @@
-+------------------------------------------------------------------+--------------+------+----------------+----------------------+--------------------+----------------------+------------------------------------------------------------------+------------------+
++------------------------------------------------------------------+--------------+------+----------------+----------------------+--------------------+---------------------+------------------------------------------------------------------+------------------+
 | col_varchar_64_key                                               | col_smallint | pk   | col_varchar_10 | col_bigint           | col_varchar_10_key | col_bigint_key       | col_varchar_64                                                   | col_smallint_key |
-+------------------------------------------------------------------+--------------+------+----------------+----------------------+--------------------+----------------------+------------------------------------------------------------------+------------------+
++------------------------------------------------------------------+--------------+------+----------------+----------------------+--------------------+---------------------+------------------------------------------------------------------+------------------+
 | was                                                              |            2 |    2 | it             |                 NULL | Texas              |                 NULL | d                                                                |           -20883 |
 | f                                                                |       -11743 |    3 | q              |                38531 | rq                 |                  206 | Nebraska                                                         |            32767 |
 | tx                                                               |        25157 |    5 | say            |                    0 | Kansas             |                  312 | Tennessee                                                        |            23992 |
 | North Dakota                                                     |            5 |    6 | htxlrqdldi     |                28024 | q                  |                    1 | oh                                                               |             NULL |
 | South Dakota                                                     |         NULL |    7 | so             |                    0 | r                  |                49513 | i                                                                |             NULL |
-| fi                                                               |            0 |    8 | a              |                49730 | want               |                   32 | ofisoh                                                           |                0 |
-| wo                                                               |         NULL |    9 | s              |                 8044 | bwofisohtx         |                    6 | some                                                             |                0 |
-| Pennsylvania                                                     |        19716 |   10 | so             |                 NULL | kb                 |  8295349038639739904 | pkbwofisohtxlrqdldihgzkeausxnmrtcfyygbitypflrddbkznryphbl        |            30209 |
-| Florida                                                          |            6 |   11 | qpkbwofiso     |                17980 | gq                 |  4528932375274460160 | Vermont                                                          |                0 |
-| Oregon                                                           |         4372 |   12 | f              |                 9885 | ffg                | -2705818951119540224 | sffgqpkbwofisohtxlrqdldihgzkeausxnmr                             |             NULL |
 | time                                                             |            7 |  145 | Oklahoma       |                 NULL | Ohio               |                31419 | ftjaddqexkvnmvtpzlrteqzjinpspukmvmhrisucmpnecjloxttvynqhmxgezt   |                2 |
 | jrdgtftj                                                         |         NULL |  147 | nj             |                    0 | b                  |  7783064581026350080 | on                                                               |                0 |
 | y                                                                |         NULL |  148 | vbnjrdgtft     |     3659174697238530 | f                  |                   92 | Hawaii                                                           |                3 |
@@ -809,4 +804,4 @@
 | m                                                                |         NULL | 1556 | see            |                    0 | jmtrfgjefm         |                    6 | n                                                                |             NULL |
 | l                                                                |        32767 | 1557 | Nevada         |                64779 | out                |                50042 | y                                                                |                7 |
 | i                                                                |            8 | 1561 | t              |  8283245614641179648 | gs                 |                    1 | m                                                                |             NULL |
-+------------------------------------------------------------------+--------------+------+----------------+----------------------+--------------------+----------------------+------------------------------------------------------------------+------------------+
++------------------------------------------------------------------+--------------+------+----------------+----------------------+--------------------+---------------------+------------------------------------------------------------------+------------------+