=== modified file 'config/ac-macros/maintainer.m4'
--- config/ac-macros/maintainer.m4	2011-02-20 16:51:43 +0000
+++ config/ac-macros/maintainer.m4	2012-02-09 14:55:03 +0000
@@ -20,7 +20,7 @@ AC_DEFUN([MY_MAINTAINER_MODE_WARNINGS],
                [INTEL_COMPILER=no], [INTEL_COMPILER=yes])
   # Setup GCC warning options.
   AS_IF([test "$GCC" = "yes" -a "$INTEL_COMPILER" = "no"], [
-    C_WARNINGS="-Wall -Wextra -Wunused -Wwrite-strings -Wno-strict-aliasing -Werror -DFORCE_INIT_OF_VARS"
+    C_WARNINGS="-Wall -Wextra -Wunused -Wwrite-strings -Wno-strict-aliasing -DFORCE_INIT_OF_VARS"
     CXX_WARNINGS="${C_WARNINGS} -Wno-unused-parameter"
     C_WARNINGS="${C_WARNINGS} -Wdeclaration-after-statement"
   ])

=== modified file 'config/ac-macros/misc.m4'
--- config/ac-macros/misc.m4	2010-01-15 15:27:55 +0000
+++ config/ac-macros/misc.m4	2012-02-09 14:53:47 +0000
@@ -7,8 +7,8 @@ AC_CACHE_CHECK([base type of last arg to
 AC_LANG_PUSH(C++)
 if test "$ac_cv_prog_gxx" = "yes"
 then
-  # Add -Werror, remove -fbranch-probabilities (Bug #268)
-  CXXFLAGS=`echo "$CXXFLAGS -Werror" | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-Wcheck//'`
+  # Add -waaaaerror, remove -fbranch-probabilities (Bug #268)
+  CXXFLAGS=`echo "$CXXFLAGS " | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-Wcheck//'`
 fi
 mysql_cv_btype_last_arg_accept=none
 [AC_TRY_COMPILE([#if defined(inline)
@@ -67,8 +67,8 @@ AC_CACHE_CHECK([struct type to use with
 AC_LANG_PUSH(C++)
 if test "$ac_cv_prog_gxx" = "yes"
 then
-  # Add -Werror, remove -fbranch-probabilities (Bug #268)
-  CXXFLAGS=`echo "$CXXFLAGS -Werror" | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-Wcheck//'`
+  # Add -Weaaaarror, remove -fbranch-probabilities (Bug #268)
+  CXXFLAGS=`echo "$CXXFLAGS " | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-Wcheck//'`
 fi
 mysql_cv_btype_struct_rlimit=none
 [AC_TRY_COMPILE([#if defined(inline)

=== modified file 'configure.in'
--- configure.in	2011-10-11 10:55:42 +0000
+++ configure.in	2012-02-09 14:53:47 +0000
@@ -283,7 +283,7 @@ AC_SUBST(NM)dnl
 # NM= "$NM -X64"
 #archive_expsym_cmds= `echo "$archive_expsym_cmds" | sed -e '/"$(CC)"//'`
 #archive_expsym_cmds= "$CC -q64 $archive_expsym_cmds"
-#  CXXFLAGS=`echo "$CXXFLAGS -Werror" | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-ansi//; s/-pedantic//; s/-Wcheck//'`
+#  CXXFLAGS=`echo "$CXXFLAGS | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-ansi//; s/-pedantic//; s/-Wcheck//'`
 
 #AC_LIBTOOL_DLOPEN AC_LIBTOOL_WIN32_DLL AC_DISABLE_FAST_INSTALL AC_DISABLE_SHARED AC_DISABLE_STATIC
 
@@ -1579,7 +1579,7 @@ fi
 #
 AC_MSG_CHECKING([for OpenSolaris Bug 6611808])
 save_CFLAGS="$CFLAGS"
-CFLAGS="$CFLAGS -Werror"
+CFLAGS="$CFLAGS "
 AC_COMPILE_IFELSE([
   #include <pthread.h>
   void dummy() {}
@@ -2265,11 +2265,11 @@ AC_CHECK_DECLS(madvise, [], [], [#if HAV
 # We also remove the -fbranch-probabilities option as this will give warnings
 # about not profiled code, which confuses configure
 # We also must remove -W and -Wcheck which on icc produces warnings that
-# we don't want to catch with -Werror
+# we don't want to catch with 
 
 if test "$ac_cv_prog_gxx" = "yes" -a "$with_other_libc" = "no"
 then
-  CXXFLAGS=`echo "$CXXFLAGS -Werror" | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-ansi//; s/-pedantic//; s/-Wcheck//'`
+  CXXFLAGS=`echo "$CXXFLAGS " | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-ansi//; s/-pedantic//; s/-Wcheck//'`
 fi
 
 AC_TRY_COMPILE(
@@ -2304,7 +2304,7 @@ AC_LANG_SAVE
 AC_LANG_CPLUSPLUS
 if test "$ac_cv_prog_gxx" = "yes" -a "$with_other_libc" = "no"
 then
-  CXXFLAGS=`echo "$CXXFLAGS -Werror" | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-ansi//; s/-pedantic//; s/-Wcheck//'`
+  CXXFLAGS=`echo "$CXXFLAGS " | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-ansi//; s/-pedantic//; s/-Wcheck//'`
 fi
 AC_TRY_COMPILE(
 [#undef inline
@@ -2337,7 +2337,7 @@ AC_LANG_SAVE
 AC_LANG_CPLUSPLUS
 if test "$ac_cv_prog_gxx" = "yes" -a "$with_other_libc" = "no"
 then
-  CXXFLAGS=`echo "$CXXFLAGS -Werror" | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-ansi//; s/-pedantic//; s/-Wcheck//'`
+  CXXFLAGS=`echo "$CXXFLAGS " | sed -e 's/-fbranch-probabilities//; s/-Wall//; s/-ansi//; s/-pedantic//; s/-Wcheck//'`
 fi
 AC_TRY_COMPILE(
 [#undef inline

=== modified file 'libmysql/acinclude.m4'
--- libmysql/acinclude.m4	2000-07-31 19:29:14 +0000
+++ libmysql/acinclude.m4	2012-02-09 14:55:03 +0000
@@ -7,7 +7,7 @@ AC_LANG_SAVE
 AC_LANG_CPLUSPLUS
 if test "$ac_cv_prog_gxx" = "yes"
 then
-  CXXFLAGS="$CXXFLAGS -Werror"
+  CXXFLAGS="$CXXFLAGS "
 fi
 mysql_cv_btype_last_arg_accept=none
 [AC_TRY_COMPILE([#include <stdlib.h>

=== modified file 'plugin/handler_socket/configure.ac'
--- plugin/handler_socket/configure.ac	2011-06-07 11:19:49 +0000
+++ plugin/handler_socket/configure.ac	2012-02-09 14:55:03 +0000
@@ -4,7 +4,7 @@
 #AC_PREREQ([2.63b])
 AC_INIT([handlersocket-plugin], [1.0.6], [https://github.com/ahiguti/HandlerSocket-Plugin-for-MySQL/issues])
 AC_CONFIG_HEADERS([config.h])
-AM_INIT_AUTOMAKE([-Wall -Werror foreign])
+AM_INIT_AUTOMAKE([-Wall foreign])
 AC_CONFIG_SRCDIR([libhsclient/fatal.cpp])
 AC_CONFIG_MACRO_DIR([m4])
 
@@ -133,7 +133,7 @@ if test "$enable_handlersocket_server" !
 fi
 AC_SUBST(HANDLERSOCKET_SUBDIRS)
 
-CFLAGS="$CFLAGS -Werror"
+CFLAGS="$CFLAGS"
 CXXFLAGS="$CXXFLAGS -Wall -g -fno-rtti -fno-exceptions -fPIC -DPIC"
 
 AC_CONFIG_FILES([Makefile