diff -Narup ./020_mariadb-10.0.15-bulk_access/sql/handler.h ./021_mariadb-10.0.15-merge_table/sql/handler.h
--- ./020_mariadb-10.0.15-bulk_access/sql/handler.h	2014-11-29 17:05:04.680795203 +0900
+++ ./021_mariadb-10.0.15-merge_table/sql/handler.h	2014-11-29 17:05:18.590797313 +0900
@@ -1388,7 +1388,8 @@ static inline sys_var *find_hton_sysvar(
 #define HTON_TEMPORARY_NOT_SUPPORTED (1 << 6) //Having temporary tables not supported
 #define HTON_SUPPORT_LOG_TABLES      (1 << 7) //Engine supports log tables
 #define HTON_NO_PARTITION            (1 << 8) //Not partition of these tables
-#define HTON_CAN_MULTISTEP_MERGE     (1 << 9) //You can merge mearged tables
+#define HTON_CAN_MERGE               (1 << 9) //Merge type table
+#define HTON_CAN_MULTISTEP_MERGE     (1 << 10) //You can merge mearged tables
 
 /*
   This flag should be set when deciding that the engine does not allow
diff -Narup ./020_mariadb-10.0.15-bulk_access/sql/sql_admin.cc ./021_mariadb-10.0.15-merge_table/sql/sql_admin.cc
--- ./020_mariadb-10.0.15-bulk_access/sql/sql_admin.cc	2014-11-22 06:02:56.000000000 +0900
+++ ./021_mariadb-10.0.15-merge_table/sql/sql_admin.cc	2014-11-29 17:05:18.605505664 +0900
@@ -182,7 +182,7 @@ static int prepare_for_repair(THD *thd, 
     goto end;					// No data file
 
   /* A MERGE table must not come here. */
-  DBUG_ASSERT(table->file->ht->db_type != DB_TYPE_MRG_MYISAM);
+  DBUG_ASSERT(!(table->file->ht->flags & HTON_CAN_MERGE));
 
   // Name of data file
   strxmov(from, table->s->normalized_path.str, ext[1], NullS);
diff -Narup ./020_mariadb-10.0.15-bulk_access/sql/sql_base.cc ./021_mariadb-10.0.15-merge_table/sql/sql_base.cc
--- ./020_mariadb-10.0.15-bulk_access/sql/sql_base.cc	2014-11-29 17:04:34.520797809 +0900
+++ ./021_mariadb-10.0.15-merge_table/sql/sql_base.cc	2014-11-29 17:05:19.629547341 +0900
@@ -1329,7 +1329,7 @@ TABLE_LIST* find_dup_table(THD *thd, TAB
   if (table->table)
   {
     /* All MyISAMMRG children are plain MyISAM tables. */
-    DBUG_ASSERT(table->table->file->ht->db_type != DB_TYPE_MRG_MYISAM);
+    DBUG_ASSERT(!(table->table->file->ht->flags & HTON_CAN_MERGE));
 
     /* temporary table is always unique */
     if (table->table && table->table->s->tmp_table != NO_TMP_TABLE)
@@ -1436,7 +1436,7 @@ unique_table(THD *thd, TABLE_LIST *table
   TABLE_LIST *dup;
   if (table->table &&
     (
-      table->table->file->ht->db_type == DB_TYPE_MRG_MYISAM ||
+      (table->table->file->ht->flags & HTON_CAN_MERGE) ||
       (table->table->file->ha_table_flags() & HA_CAN_MULTISTEP_MERGE)
     )
   ) {
@@ -1449,7 +1449,7 @@ unique_table(THD *thd, TABLE_LIST *table
       if (
         child->table &&
         (
-          child->table->file->ht->db_type == DB_TYPE_MRG_MYISAM ||
+          (child->table->file->ht->flags & HTON_CAN_MERGE) ||
           (child->table->file->ha_table_flags() & HA_CAN_MULTISTEP_MERGE)
         )
       )
@@ -4615,7 +4615,7 @@ restart:
     /* Schema tables may not have a TABLE object here. */
     if (tbl &&
       (
-        tbl->file->ht->db_type == DB_TYPE_MRG_MYISAM ||
+        (tbl->file->ht->flags & HTON_CAN_MERGE) ||
         (tbl->file->ha_table_flags() & HA_CAN_MULTISTEP_MERGE)
       )
     ) {
@@ -5062,7 +5062,7 @@ TABLE *open_ltable(THD *thd, TABLE_LIST 
     DBUG_ASSERT(table_list->table);
     table= table_list->table;
     if (
-      table->file->ht->db_type == DB_TYPE_MRG_MYISAM ||
+      (table->file->ht->flags & HTON_CAN_MERGE) ||
       (table->file->ha_table_flags() & HA_CAN_MULTISTEP_MERGE)
     ) {
       /* A MERGE table must not come here. */
diff -Narup ./020_mariadb-10.0.15-bulk_access/storage/myisammrg/ha_myisammrg.cc ./021_mariadb-10.0.15-merge_table/storage/myisammrg/ha_myisammrg.cc
--- ./020_mariadb-10.0.15-bulk_access/storage/myisammrg/ha_myisammrg.cc	2014-11-22 06:02:56.000000000 +0900
+++ ./021_mariadb-10.0.15-merge_table/storage/myisammrg/ha_myisammrg.cc	2014-11-29 17:05:19.687796737 +0900
@@ -1764,7 +1764,7 @@ static int myisammrg_init(void *p)
   myisammrg_hton->db_type= DB_TYPE_MRG_MYISAM;
   myisammrg_hton->create= myisammrg_create_handler;
   myisammrg_hton->panic= myisammrg_panic;
-  myisammrg_hton->flags= HTON_NO_PARTITION;
+  myisammrg_hton->flags= HTON_NO_PARTITION | HTON_CAN_MERGE;
   myisammrg_hton->tablefile_extensions= ha_myisammrg_exts;
 
   return 0;